^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 1) #!/bin/bash
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 2) # SPDX-License-Identifier: GPL-2.0
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 3) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 4) # Translate stack dump function offsets.
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 5) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 6) # addr2line doesn't work with KASLR addresses. This works similarly to
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 7) # addr2line, but instead takes the 'func+0x123' format as input:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 8) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 9) # $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 10) # meminfo_proc_show+0x5/0x568:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 11) # meminfo_proc_show at fs/proc/meminfo.c:27
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 12) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 13) # If the address is part of an inlined function, the full inline call chain is
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 14) # printed:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 15) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 16) # $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 17) # native_write_msr+0x6/0x27:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 18) # arch_static_branch at arch/x86/include/asm/msr.h:121
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 19) # (inlined by) static_key_false at include/linux/jump_label.h:125
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 20) # (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 21) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 22) # The function size after the '/' in the input is optional, but recommended.
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 23) # It's used to help disambiguate any duplicate symbol names, which can occur
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 24) # rarely. If the size is omitted for a duplicate symbol then it's possible for
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 25) # multiple code sites to be printed:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 26) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 27) # $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 28) # raw_ioctl+0x5/0x20:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 29) # raw_ioctl at drivers/char/raw.c:122
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 30) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 31) # raw_ioctl+0x5/0xb1:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 32) # raw_ioctl at net/ipv4/raw.c:876
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 33) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 34) # Multiple addresses can be specified on a single command line:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 35) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 36) # $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 37) # type_show+0x10/0x2d:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 38) # type_show at drivers/video/backlight/backlight.c:213
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 39) #
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 40) # free_reserved_area+0x90/0x123:
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 41) # free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 42)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 43)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 44) set -o errexit
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 45) set -o nounset
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 46)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 47) READELF="${CROSS_COMPILE:-}readelf"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 48) ADDR2LINE="${CROSS_COMPILE:-}addr2line"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 49) SIZE="${CROSS_COMPILE:-}size"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 50) NM="${CROSS_COMPILE:-}nm"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 51)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 52) command -v awk >/dev/null 2>&1 || die "awk isn't installed"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 53) command -v ${READELF} >/dev/null 2>&1 || die "readelf isn't installed"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 54) command -v ${ADDR2LINE} >/dev/null 2>&1 || die "addr2line isn't installed"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 55) command -v ${SIZE} >/dev/null 2>&1 || die "size isn't installed"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 56) command -v ${NM} >/dev/null 2>&1 || die "nm isn't installed"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 57)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 58) usage() {
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 59) echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 60) exit 1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 61) }
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 62)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 63) warn() {
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 64) echo "$1" >&2
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 65) }
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 66)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 67) die() {
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 68) echo "ERROR: $1" >&2
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 69) exit 1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 70) }
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 71)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 72) # Try to figure out the source directory prefix so we can remove it from the
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 73) # addr2line output. HACK ALERT: This assumes that start_kernel() is in
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 74) # init/main.c! This only works for vmlinux. Otherwise it falls back to
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 75) # printing the absolute path.
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 76) find_dir_prefix() {
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 77) local objfile=$1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 78)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 79) local start_kernel_addr=$(${READELF} -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}')
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 80) [[ -z $start_kernel_addr ]] && return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 81)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 82) local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 83) [[ -z $file_line ]] && return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 84)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 85) local prefix=${file_line%init/main.c:*}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 86) if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 87) return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 88) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 89)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 90) DIR_PREFIX=$prefix
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 91) return 0
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 92) }
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 93)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 94) __faddr2line() {
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 95) local objfile=$1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 96) local func_addr=$2
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 97) local dir_prefix=$3
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 98) local print_warnings=$4
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 99)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 100) local func=${func_addr%+*}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 101) local offset=${func_addr#*+}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 102) offset=${offset%/*}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 103) local size=
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 104) [[ $func_addr =~ "/" ]] && size=${func_addr#*/}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 105)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 106) if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 107) warn "bad func+offset $func_addr"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 108) DONE=1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 109) return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 110) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 111)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 112) # Go through each of the object's symbols which match the func name.
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 113) # In rare cases there might be duplicates.
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 114) file_end=$(${SIZE} -Ax $objfile | awk '$1 == ".text" {print $2}')
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 115) while read symbol; do
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 116) local fields=($symbol)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 117) local sym_base=0x${fields[0]}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 118) local sym_type=${fields[1]}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 119) local sym_end=${fields[3]}
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 120)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 121) # calculate the size
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 122) local sym_size=$(($sym_end - $sym_base))
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 123) if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 124) warn "bad symbol size: base: $sym_base end: $sym_end"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 125) DONE=1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 126) return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 127) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 128) sym_size=0x$(printf %x $sym_size)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 129)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 130) # calculate the address
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 131) local addr=$(($sym_base + $offset))
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 132) if [[ -z $addr ]] || [[ $addr = 0 ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 133) warn "bad address: $sym_base + $offset"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 134) DONE=1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 135) return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 136) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 137) addr=0x$(printf %x $addr)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 138)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 139) # weed out non-function symbols
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 140) if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 141) [[ $print_warnings = 1 ]] &&
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 142) echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 143) continue
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 144) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 145)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 146) # if the user provided a size, make sure it matches the symbol's size
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 147) if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 148) [[ $print_warnings = 1 ]] &&
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 149) echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 150) continue;
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 151) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 152)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 153) # make sure the provided offset is within the symbol's range
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 154) if [[ $offset -gt $sym_size ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 155) [[ $print_warnings = 1 ]] &&
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 156) echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 157) continue
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 158) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 159)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 160) # separate multiple entries with a blank line
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 161) [[ $FIRST = 0 ]] && echo
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 162) FIRST=0
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 163)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 164) # pass real address to addr2line
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 165) echo "$func+$offset/$sym_size:"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 166) local file_lines=$(${ADDR2LINE} -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;")
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 167) [[ -z $file_lines ]] && return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 168)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 169) if [[ $LIST = 0 ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 170) echo "$file_lines" | while read -r line
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 171) do
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 172) echo $line
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 173) done
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 174) DONE=1;
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 175) return
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 176) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 177)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 178) # show each line with context
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 179) echo "$file_lines" | while read -r line
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 180) do
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 181) echo
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 182) echo $line
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 183) n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 184) n1=$[$n-5]
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 185) n2=$[$n+5]
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 186) f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 187) awk 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 188) done
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 189)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 190) DONE=1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 191)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 192) done < <(${NM} -n $objfile | awk -v fn=$func -v end=$file_end '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, "0x"$1 } END {if (found == 1) print line, end; }')
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 193) }
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 194)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 195) [[ $# -lt 2 ]] && usage
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 196)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 197) objfile=$1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 198)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 199) LIST=0
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 200) [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 201)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 202) [[ ! -f $objfile ]] && die "can't find objfile $objfile"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 203) shift
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 204)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 205) DIR_PREFIX=supercalifragilisticexpialidocious
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 206) find_dir_prefix $objfile
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 207)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 208) FIRST=1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 209) while [[ $# -gt 0 ]]; do
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 210) func_addr=$1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 211) shift
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 212)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 213) # print any matches found
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 214) DONE=0
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 215) __faddr2line $objfile $func_addr $DIR_PREFIX 0
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 216)
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 217) # if no match was found, print warnings
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 218) if [[ $DONE = 0 ]]; then
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 219) __faddr2line $objfile $func_addr $DIR_PREFIX 1
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 220) warn "no match for $func_addr"
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 221) fi
^8f3ce5b39 (kx 2023-10-28 12:00:06 +0300 222) done